#include <bits/stdc++.h>
#pragma optimize("O2")
#define ll int
#define ve vector
#define ldb long double
#define pb push_back

using namespace std;
ll n, m, k;
ve<ve<ll>> edges;
ve<ll> dp;
queue<ll> q; // самые сильные охранники
ve<ll> dq; // слабые
ve<bool> added;

bool cmp(ll a, ll b){
    return a > b;
}

void bfs(){
    while(true) {
        if (q.empty()) {
            if (dq.empty())
                return;
            ll mx = dp[dq.back()];
            while (!dq.empty() && dp[dq.back()] == mx) {
                q.push(dq.back());
                dq.pop_back();
            }
        }
        while (!q.empty()) {
            ll v = q.front();
            q.pop();
            added[v] = false;
            for (auto it: edges[v]) {
                if (dp[it] < dp[v] - 1) {
                    dp[it] = dp[v] - 1;
                    if (!added[it]) {
                        dq.push_back(it);
                        added[it] = true;
                    }
                }
            }
        }
    }
}

int main() {
#ifdef DEBUG_Q
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    ll i, j;
    cin >> n >> m >> k;
    edges.resize(n);
    added.assign(n, false);
    dp.assign(n, -1);
    for(i = 0; i < m; i++){
        ll x, y;
        cin >> x >> y;
        x--;
        y--;
        edges[x].pb(y);
        edges[y].pb(x);
    }
    ll p[k];
    ll mx = 0;
    for(i = 0; i < k; i++){
        ll x, y;
        cin >> x >> y;
        x--;
        p[i] = x;
        dp[x] = max(y, dp[x]);
        mx = max(mx, dp[x]);
    }
    for(i = 0; i < n; i++){
        if(dp[i] == mx){
            q.push(i);
            added[i] = true;
        } else if(dp[i] != -1){
            dq.push_back(i);
        }
    }
    bfs();
    ll cnt = 0;
    for(i = 0; i < n; i++){
        if(dp[i] >= 0)
            cnt++;
    }
    cout << cnt << endl;
    for(i = 0; i < n; i++){
        if(dp[i] >= 0){
            cout << i + 1 << " ";
        }
    }
}