#include <bits/stdc++.h>
#include <math.h>

#pragma optimize("O2")
#define ll long long
#define ve vector
#define ldb long double
#define pb push_back
#define x first
#define y second
using namespace std;
ldb const pi = acos(-1);
ldb const alpha = 2 * pi / 1000000;
ldb const inf = 1e9;

void prod_matrix(pair<ldb, ldb> &a, ll kof) {
    pair<ldb, ldb> ap;
    ap.x = cos(alpha * kof) * a.x + sin(alpha * kof) * a.y;
    ap.y = -sin(alpha * kof) * a.x + cos(alpha * kof) * a.y;
    a = ap;
}

ldb dist(pair<ldb, ldb> a, pair<ldb, ldb> b) {
    return abs(a.x - b.x) + abs(a.y - b.y);
}

int main() {
#ifdef DEBUG_Q
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ll n;
    cin >> n;
    ll i, j;
    cout << fixed << setprecision(8);
    if (n == 2) {
        pair<ll, ll> a, b;
        cin >> a.x >> a.y >> b.x >> b.y;
        cout << sqrt((a.x - b.x) * (a.x - b.x) + (a.y - b.y) * (a.y - b.y));
    }
    pair<ldb, ldb> cor[n];
    for (i = 0; i < n; i++) {
        cin >> cor[i].x >> cor[i].y;
    }
    ldb mn = inf;
    for (ll k = 0; k < 1000000; k++) {
        pair<ldb, ldb> copy[n];
        for (i = 0; i < n; i++) {
            copy[i] = cor[i];
        }
        for (i = 0; i < n; i++) {
            prod_matrix(copy[i], k);
        }
        ldb sum1 = dist(copy[0], copy[1]) + dist(copy[2], copy[1]);
        ldb sum2 = dist(copy[0], copy[2]) + dist(copy[2], copy[1]);
        ldb sum3 = dist(copy[0], copy[1]) + dist(copy[0], copy[2]);
        mn = min(mn, sum1);
        mn = min(mn, sum2);
        mn = min(mn, sum3);
    }
    cout << mn;
}